#include <PalmOS.h>
#include <PalmCompatibility.h>
#include <Common/Libraries/TonesLibrary/TonesLibTypes.h>
#include <68k/Libraries/TonesLibrary/TonesLib.h>
#include <68k/System/HsExt.h>

extern void TurnOffKeyGuard();
extern void InitSoundsLib();
extern void PlaySystemAlarm(UInt16 playCount);
extern void CleanupSoundsLib();

UInt16 tonesLibRef=0;

void TurnOffKeyGuard() {
  UInt32 keyguard;
  HsAttrGet (hsAttrKeyboardLocked, 0, &keyguard);
  if (keyguard) { 
    keyguard = 0; 
    HsAttrSet(hsAttrKeyboardLocked, 0, &keyguard); 
  }
}
void InitSoundsLib() {
  int error = SysLibFind(tonesLibName, &tonesLibRef);
  if (error == 0)
  { 
    SysLibLoad(tonesLibType, tonesLibCreator ,&tonesLibRef);
  }
  if (tonesLibRef != 0) {
    error = TonesLibOpen(tonesLibRef);
  }
}
void CleanupSoundsLib() {
  TonesLibClose(tonesLibRef);
}

void PlaySystemAlarm(UInt16 playCount) {
  Err err;
  SoundPreference *soundPref;
  ToneIdentifier toneIdent;
  ToneVolume volume;
  Boolean vibrate;
  
  soundPref=MemPtrNew(sizeof(SoundPreference));
  err = TonesLibGetSoundPrefs (tonesLibRef,
    soundPrefTypeCalendar, soundPref);
  toneIdent = soundPref->tonePrefs.calendarSoundPrefs.alarmTone;
  volume = soundPref->soundOnVolume;
  vibrate = soundPref->soundOnVibrate;
  err = TonesLibPlayTone (tonesLibRef, toneIdent,playCount, volume ,vibrate, true);
  MemPtrFree(soundPref);
}
